//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert       = "Steppin Ma";
extern bool   EcnBroker         = true;
extern string SymbolsPrefix     = "";
extern string SymbolsSuffix     = "";
extern bool   UseAutoMagic      = true;
extern int    ManualMagic       = 81818181;  
extern double lStopLoss         = 50;
extern double sStopLoss         = 50;
extern double lTakeProfit       = 100;
extern double sTakeProfit       = 100;
extern double lTrailingStop     = 25;
extern double sTrailingStop     = 25;
extern int    Slippage          = 4;
extern double Lots              = 0.10;
extern double MaximumRisk       = 0.00;
extern double DecreaseFactor    = 3;

extern int    Length            = 10;        // Volty Length
extern double Kv                = 1;         // Sensivity Factor
extern int    MA_Mode           = 0;         // Volty MA Mode : 0-SMA, 1-LWMA 
extern int    StepSizeMIN       = 0;         // Minimum Step Size  (if need)
extern int    StepSizeMAX       = 0;         // Maximum Step Size  (if need)
extern int    ShiftMIN          = 0; 
extern int    ShiftMID          = 0;
extern int    ShiftMAX          = 0;
extern int    bar               = 1;

extern string __ReEntry         = "Using Rentry";
extern bool   UseReEntry        = true;

extern bool   UseStepMaClose    = false;
extern int    Close.Length      = 10;
extern double Close.Kv          = 1;
extern int    Close.MA_Mode     = 0;
extern int    Close.StepSizeMIN = 0;
extern int    Close.StepSizeMAX = 0;
extern int    Close.ShiftMIN    = 0;
extern int    Close.ShiftMID    = 0;
extern int    Close.ShiftMAX    = 0;
extern int    Close.bar         = 1;

extern bool   SpreadProtection  = true;       // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance      = 5;          // value in pips over normal spread to activate the SpreadProtection.

extern string _time             = "Time Filter";
extern int    StartHour         = 0;          // Start Hour of Trade Session 
extern int    StartMinute       = 0;          // Start Minute of Trade Session 
extern int    EndHour           = 23;         // End Hour of Trade Session
extern int    EndMinute         = 0;          // End Hour of Trade Session

extern string OtherStuff        = "Other stuff";
extern bool   ShowAlerts        = true;
extern color  clOpenBuy         = Blue;
extern color  clCloseBuy        = Aqua;
extern color  clOpenSell        = Red;
extern color  clCloseSell       = Violet;

//
//
//
//
//

double pipMultiplier = 1;
double Spread,WorstSpread,NormalSpread;

string s_symbol;

int    DontContinue;
int    MAGIC;
int    digit = 0;

//
//
//
//
//

int init() 
{

  s_symbol = Symbol();
  
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic; 
              
  digit        = MarketInfo(s_symbol,MODE_DIGITS);           
  NormalSpread = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,digit%2); 
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   
   if (digit==3 || digit==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;               

   //
   //
   //
   //
   //
   
   if(Bars < 100)        {  Print("bars less than 100");      return(0);  }
   if (lStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if (lTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   if (sStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if (sTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   
   //
   //
   //
   //
   //
   
   Spread = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,digit%2);   
   
   if (Spread > WorstSpread) WorstSpread = Spread;
   if (SpreadProtection && Spread > NormalSpread + PipTolerance) { DontContinue = 1; }  
                                                           else  { DontContinue = 0; }
   
   //
   //
   //
   //
   //
   
   double fastmanow = iCustom(s_symbol,0,"StepMA_3D_v3",Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,0,bar);
   double fastmapre = iCustom(s_symbol,0,"StepMA_3D_v3",Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,0,bar+1);
   
   double slowmanow = iCustom(s_symbol,0,"StepMA_3D_v3",Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,1,bar);
   double slowmapre = iCustom(s_symbol,0,"StepMA_3D_v3",Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,1,bar+1);
   
   double midmanow  = iCustom(s_symbol,0,"StepMA_3D_v3",Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,2,bar);
   double midmapre  = iCustom(s_symbol,0,"StepMA_3D_v3",Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,2,bar+1);
   
   //
   //
   //
   //
   //
   
   if (UseReEntry)
   {
      bool reEntryBuy  = (fastmanow > midmanow && fastmapre < midmanow && midmanow > slowmanow);
      bool reEntrySell = (fastmanow < midmanow && fastmapre > midmanow && midmanow < slowmanow);
   }
   else      
   {
      reEntryBuy  = true;
      reEntrySell = true;
   }
   
   //
   //
   //
   //
   //
   
   if (!ExistPositions())
   {
      
      if ((reEntryBuy && TimeCondition() && DontContinue == 0)   ||  (fastmanow > midmanow && fastmapre < midmapre && midmanow > slowmanow && TimeCondition() && DontContinue == 0)) 
      {
         OpenBuy();
         return(0);
      }

      if ((reEntrySell && TimeCondition() && DontContinue == 0)  ||  (fastmanow < midmanow && fastmapre > midmapre && midmanow < slowmanow && TimeCondition() && DontContinue == 0)) 
      {
         OpenSell();
         return(0);
      }
  
   }
   
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   if(UseStepMaClose)   CheckForClose();
   
return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid - OrderOpenPrice()     > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss()   < Bid - trailingStop * Point * pipMultiplier) 
                     ModifyStopLoss(Bid       - trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + trailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                     ModifyStopLoss(Ask     + trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = GetStopLossBuy(); 
   double lbTake = GetTakeProfitBuy();
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts  == true) Alert(ErrAlert);


           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = GetStopLossSell(); 
   double lsTake = GetTakeProfitSell();
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int  sellTicket   = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if  (sellTicket  >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts  == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
    }		       
}

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double clfastmanow = iCustom(s_symbol,0,"StepMA_3D_v3",Close.Length,Close.Kv,Close.MA_Mode,Close.StepSizeMIN,Close.StepSizeMAX,Close.ShiftMIN,Close.ShiftMID,Close.ShiftMAX,0,Close.bar);
   double clfastmapre = iCustom(s_symbol,0,"StepMA_3D_v3",Close.Length,Close.Kv,Close.MA_Mode,Close.StepSizeMIN,Close.StepSizeMAX,Close.ShiftMIN,Close.ShiftMID,Close.ShiftMAX,0,Close.bar+1);
   
   double clslowmanow = iCustom(s_symbol,0,"StepMA_3D_v3",Close.Length,Close.Kv,Close.MA_Mode,Close.StepSizeMIN,Close.StepSizeMAX,Close.ShiftMIN,Close.ShiftMID,Close.ShiftMAX,1,Close.bar);
   double clslowmapre = iCustom(s_symbol,0,"StepMA_3D_v3",Close.Length,Close.Kv,Close.MA_Mode,Close.StepSizeMIN,Close.StepSizeMAX,Close.ShiftMIN,Close.ShiftMID,Close.ShiftMAX,1,Close.bar+1);
   
   double clmidmanow  = iCustom(s_symbol,0,"StepMA_3D_v3",Close.Length,Close.Kv,Close.MA_Mode,Close.StepSizeMIN,Close.StepSizeMAX,Close.ShiftMIN,Close.ShiftMID,Close.ShiftMAX,2,Close.bar);
   double clmidmapre  = iCustom(s_symbol,0,"StepMA_3D_v3",Close.Length,Close.Kv,Close.MA_Mode,Close.StepSizeMIN,Close.StepSizeMAX,Close.ShiftMIN,Close.ShiftMID,Close.ShiftMAX,2,Close.bar+1);
   
   
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (clfastmanow < clmidmanow && clfastmapre > clmidmapre) 
        {
           bool Closed = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*Point*pipMultiplier,clCloseBuy);
           
           if (Closed == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (clfastmanow > clmidmanow && clfastmapre < clmidmapre) 
        {
          Closed = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*Point*pipMultiplier,clCloseSell); 
          
          if (Closed == false)
          {
            ErrorCode = GetLastError();
            ErrDesc   = ErrorDescription(ErrorCode);

            ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts  == true)  Alert(ErrAlert);

            ErrLog    = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
   }
} 

//
//
//
//
//

double GetStopLossBuy()    
{ 	
return(Bid - lStopLoss   * Point * pipMultiplier); 
} 

//
//
//
//
//

double GetStopLossSell()   
{ 	
return(Ask + sStopLoss   * Point * pipMultiplier); 
} 

//
//
//
//
//

double GetTakeProfitBuy()  
{ 	
return(Ask + lTakeProfit * Point * pipMultiplier); 
} 

//
//
//
//
//

double GetTakeProfitSell() 
{ 	
return(Bid - sTakeProfit * Point * pipMultiplier); 
} 

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
     lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
      
   if(losses > 1) lot = NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0) * lot_step;
   if(lot < lot_min) lot = lot_min;
   if(lot > lot_max) lot = lot_max;
   
   //
   //
   //
   //
   //
   
   return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(81833921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(81833922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(81833931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(81833932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(81833941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(81833942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(81833951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(81833961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(81833962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(81833963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(81833964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(81833965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(81833966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(81833967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(81833971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(81833972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(81833973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(81833981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(81833982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(81833983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(81833991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(81833992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(81833993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(81833994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(81833995);
   
return(ManualMagic);
}

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd; 
        
   else
   
   if (StartHour > EndHour)
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24) || (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
   return(result);
}  

//
//
//
//
//




